# -*- coding: utf-8 -*-
#
import mod.server.extraServerApi as serverApi

compFactory = serverApi.GetEngineCompFactory()


class CustomEntityServerSystem(serverApi.GetServerSystemCls()):
    def __init__(self, namespace, name):
        super(CustomEntityServerSystem, self).__init__(namespace, name)
        self.ListenEvent()

    def ListenEvent(self):
        self.ListenForEvent('putBlockMod', 'customEntityClientSystem', "SwitchGameMode", self, self.OnSwitchGameMode)

    def OnSwitchGameMode(self, args):
        playerId = args['playerId']
        playerComp = compFactory.CreatePlayer(playerId)
        gameType = compFactory.CreateGame(serverApi.GetLevelId()).GetPlayerGameType(playerId)
        if gameType != serverApi.GetMinecraftEnum().GameType.Survival:
            setGameType = serverApi.GetMinecraftEnum().GameType.Survival
        else:
            setGameType = serverApi.GetMinecraftEnum().GameType.Creative
        playerComp.SetPlayerGameType(setGameType)
